/***************************************************************************
 *   Copyright (C) 2004-2005 by Giovanni Venturi                           *
 *   gventuri73@tiscali.it                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA  02110-1301, USA.          *
 ***************************************************************************/

#ifndef ARPPROTOCOL_H
#define ARPPROTOCOL_H

class Packet;
class QString;
class QStringList;

#include "../packetstructures.h"

class ArpProtocol
{
public:
  ArpProtocol(Packet *packet);
  ArpProtocol(ptrPacketType packet);

  unsigned short hwType() const;
  unsigned short protocolType() const;
  unsigned char hwSize() const;
  unsigned char protocolSize() const;
  unsigned char opCode() const;
  QString senderMacAddress() const;
  QString senderIpAddress() const;
  QString targetMacAddress() const;
  QString targetIpAddress() const;
  QString strProtocol() const;

  QStringList headerLines() const;

private:
  Packet *m_packet;
  int m_length;
};

#endif
